require 'rails_helper'

# This spec was generated by rspec-rails when you ran the scaffold generator.
# It demonstrates how one might use RSpec to test the controller code that
# was generated by Rails when you ran the scaffold generator.
#
# It assumes that the implementation code is generated by the rails scaffold
# generator. If you are using any extension libraries to generate different
# controller code, this generated spec may or may not pass.
#
# It only uses APIs available in rails and/or rspec-rails. There are a number
# of tools you can use to make these specs even more expressive, but we're
# sticking to rails and rspec-rails APIs to keep things simple and stable.

RSpec.describe '/labels/criteria', type: :request do
  # Labels::Criterium. As you add validations to Labels::Criterium, be sure to
  # adjust the attributes here as well.
  let(:valid_attributes) { {name: 'Critère facilité', threshold: 1, crit_type: 'matrix'} }
  let(:invalid_attributes) { {name: nil, threshold: 1} }

  let(:crit_type_matrix) { {crit_type: 'matrix'} }
  let(:crit_type_criticity) { {crit_type: 'criticity'} }

  # let(:rca) { FactoryBot.create(:rca, methodology: methodology) }
  let(:methodology) { FactoryBot.create(:methodology, :with_step_1) }
  let(:user) { FactoryBot.create(:user) }

  context 'From logged user' do
    before :each do
      user.set_session(:active_step_tool, methodology.steps.first.step_tools.first.id)
      user.save!

      sign_in user
    end

    describe 'GET /index' do
      context 'without crit type params' do
        it 'renders a successful response' do
          Labels::Criterium.create! valid_attributes
          get labels_criteria_url
          expect(response).to be_successful
        end
      end

      context 'with crit type' do
        it 'renders a successful response' do
          Labels::Criterium.create! valid_attributes
          get labels_criteria_url, params: { labels_criterium: crit_type_matrix }
          expect(response).to be_successful
        end
      end
    end

    describe 'GET /new' do
      context 'without crit type params' do
        it 'renders a successful response' do
          get new_labels_criterium_url
          expect(response).to be_successful
        end
      end
      context 'with crit type params' do
        it 'renders a successful response' do
          get new_labels_criterium_url, params: { labels_criterium: crit_type_matrix }
          expect(response).to be_successful
        end
      end
    end

    describe 'GET /edit' do
      it 'render a successful response' do
        labels_criterium = Labels::Criterium.create! valid_attributes
        get edit_labels_criterium_url(labels_criterium)
        expect(response).to be_successful
      end
    end

    describe 'POST /create' do
      context 'with valid parameters' do
        it 'creates a new Labels::Criterium' do
          expect {
            post labels_criteria_url, params: { labels_criterium: valid_attributes }
          }.to change(Labels::Criterium, :count).by(1)
        end

        it 'redirects to the edition page' do
          post labels_criteria_url, params: { labels_criterium: valid_attributes }
          expect(response).to redirect_to(edit_labels_criterium_url(@controller.instance_variable_get(:@labels_criterium)))
        end
      end

      context 'with invalid parameters' do
        it 'does not create a new Labels::Criterium' do
          expect {
            post labels_criteria_url, params: { labels_criterium: invalid_attributes }
          }.to change(Labels::Criterium, :count).by(0)
        end

        it 'renders a successful response (i.e. to display the new template)' do
          post labels_criteria_url, params: { labels_criterium: invalid_attributes }
          expect(response).to be_successful
        end
      end
    end

    describe 'PATCH /update' do
      context 'with valid parameters' do
        let(:new_attributes) { {name: 'Nouveau critère', threshold: 2} }

        it 'updates the requested labels_criterium' do
          labels_criterium = Labels::Criterium.create! valid_attributes
          patch labels_criterium_url(labels_criterium), params: { labels_criterium: new_attributes }
          labels_criterium.reload
          expect(labels_criterium.name).to eq('Nouveau critère')
          expect(labels_criterium.threshold).to eq(2)
        end

        it 'redirects to the index page' do
          labels_criterium = Labels::Criterium.create! valid_attributes
          patch labels_criterium_url(labels_criterium), params: { labels_criterium: new_attributes }
          labels_criterium.reload
          expect(response).to redirect_to(labels_criteria_url(labels_criterium: {crit_type: labels_criterium.crit_type}))
        end
      end

      context 'with invalid parameters' do
        it 'renders a successful response (i.e. to display the edit template)' do
          labels_criterium = Labels::Criterium.create! valid_attributes
          patch labels_criterium_url(labels_criterium), params: { labels_criterium: invalid_attributes }
          expect(response).to be_successful
        end
      end
    end

    describe 'DELETE /destroy' do
      it 'destroys the requested labels_criterium' do
        labels_criterium = Labels::Criterium.create! valid_attributes
        expect {
          delete labels_criterium_url(labels_criterium)
        }.to change(Labels::Criterium, :count).by(-1)
      end

      it 'redirects to the labels_criteria list' do
        labels_criterium = Labels::Criterium.create! valid_attributes
        crit_type = labels_criterium.crit_type
        delete labels_criterium_url(labels_criterium)
        expect(response).to redirect_to(labels_criteria_url(labels_criterium: {crit_type: crit_type}))
      end
    end
  end
end
